//
//  SWCell.h
//  White Detector Grid
//
//  Created by David Langford on 9/05/09.
//  Copyright 2009 Sentient Worlds. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <Accelerate/Accelerate.h>

@interface SWCell : NSObject {
	NSNumber*						xInPixels;
	NSNumber*						yInPixels;
	NSNumber*						widthInPixels;
	NSNumber*						heightInPixels;
	NSNumber*						weight;
	
	vImagePixelCount				_histogramA[256];
	vImagePixelCount				_histogramR[256];
	vImagePixelCount				_histogramG[256];
	vImagePixelCount				_histogramB[256];
}

@property (readwrite, assign) NSNumber* xInPixels;
@property (readwrite, assign) NSNumber* yInPixels;
@property (readwrite, assign) NSNumber* widthInPixels;
@property (readwrite, assign) NSNumber* heightInPixels;
@property (readwrite, assign) NSNumber* weight;

- (id) initWithXPositionAt:(NSNumber*)startXposition
			   yPositionAt:(NSNumber*)startYposition
			 widthInPixels:(NSNumber*)startWidth
			heightInPixels:(NSNumber*)startHeight;

- (BOOL) generateWeightFromImage:(id<QCPlugInInputImageSource>)imageToUse
					   inContext:(id<QCPlugInContext>)theContext;

- (NSNumber*) generateWeightFromHistogram:(vImagePixelCount**)histograms
							usingChannel:(int)channel;

- (NSArray*) asNSArray;

@end
