//
//  SWGrid.h
//  White Detector Grid
//
//  Created by David Langford on 6/05/09.
//  Copyright 2009 Sentient Worlds. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <Accelerate/Accelerate.h>

@interface SWGrid : NSObject {
	NSNumber* 							numberOfColumns;
	NSNumber* 							numberOfRows;
	NSNumber* 							widthPixels;
	NSNumber*							heightPixels;
	NSNumber*							widthNormalised;
	NSNumber*							heightNormalised;
	NSNumber*							xOffsetNormalised;
	NSNumber*							yOffsetNormalised;
	NSNumber*							xOffsetPixels;
	NSNumber*							yOffsetPixels;
	NSArray*							cells;
}

@property (readwrite, assign) NSNumber* numberOfColumns;
@property (readwrite, assign) NSNumber* numberOfRows;
@property (readwrite, assign) NSNumber* widthPixels;
@property (readwrite, assign) NSNumber* heightPixels;
@property (readwrite, assign) NSNumber* widthNormalised;
@property (readwrite, assign) NSNumber* heightNormalised;
@property (readwrite, assign) NSNumber* xOffsetNormalised;
@property (readwrite, assign) NSNumber* yOffsetNormalised;
@property (readwrite, assign) NSNumber* xOffsetPixels;
@property (readwrite, assign) NSNumber* yOffsetPixels;
@property (retain, readwrite) NSArray* cells;

- (id) initWithNumberOfColumns:(NSNumber*)columns 
				  numberOfRows:(NSNumber*)rows
					imageToUse:(id<QCPlugInInputImageSource>)theImage
				   withContext:(id<QCPlugInContext>)theContext
				  widthPercent:(NSNumber*)theWidthPercent
				 heightPercent:(NSNumber*)theHeightPercent
				xOriginPercent:(NSNumber*)theXOriginPercent
				yOriginPercent:(NSNumber*)theYOriginPercent;
- (NSArray*) generateCellsUsingImage:(id<QCPlugInInputImageSource>)imageToUse
						  andContext:(id<QCPlugInContext>)theContext;
- (NSArray*) asNSArray;

@end
